/*      90_20.Is
	Application specific execution module.
	device: T/XSDAS-AD8-DA8-100/12

|RRes|XRes|RInt|RTInt|XInt|XTInt| RLen | XLen |FSRP|FSXP|DRP|DXP|CLKRP|CLKXP|
 27   26   25    24  | 23   22   21 20 |19 18   17   16 | 15  14  13    12
-------------------------------------------------------------------------------
|RFSM|XFSM|RVAREN|XVAREN|RCLKSRCE|XCLKSRCE|HS|RSRFULL|XSREMPTY|FSXOUT|XRDY|RRDY|
| 11   10    9      8   |   7        6      5    4   |   3       2      1    0

*/


#define	SIO_GC_DATA_MODE		0x29b1204 /* XLen=24bits
						   for RLen=16bits
						   Ext xclk & rclk  */
#define	SIO_GC_GO_MASK			0xc000000
#define	SIO_XC_DATA_MODE		0x111
#define	SIO_RC_DATA_MODE		0x111

#define SIO_RXTC_DATA_MODE		0x8
#define SIO_RXTC_GO_MASK		0x3
#define SIO_RXTPER_DATA_MODE		0x1


#define TM_GC_DATA			0x303
#define TM_PER_DATA			800
#define TM_GC_GO_MASK			0xc0


void init_sio()
 { int i;

	*C3X_SIO0_GC = SIO_GC_DATA_MODE  ;
	*C3X_SIO0_XC = SIO_XC_DATA_MODE  ;
	*C3X_SIO0_RC = SIO_RC_DATA_MODE  ;
	*C3X_SIO0_GC = SIO_GC_DATA_MODE | SIO_GC_GO_MASK ;

	*C3X_SIO0_RXTC		= SIO_RXTC_DATA_MODE;
	*C3X_SIO0_RXTPER	= SIO_RXTPER_DATA_MODE;
	*C3X_SIO0_RXTC		= SIO_RXTC_DATA_MODE | SIO_RXTC_GO_MASK;

	*C3X_SIO0_XD = 0;

	C3X_SR0_INT_CLEAR;
	C3X_SR0_INT_ENABLE;

	*C3X_SIO0_GC = SIO_GC_DATA_MODE | SIO_GC_GO_MASK ;

	*C3X_TM1_GC		= TM_GC_DATA;
	*C3X_TM1_PER		= TM_PER_DATA	;
	*C3X_TM1_GC		= TM_GC_DATA | TM_GC_GO_MASK	;

	*C3X_TM0_GC		= TM_GC_DATA;
	*C3X_TM0_PER		= TM_PER_DATA	;
        for(i=0;i<100;i++); /* delay TM0 start to avoid DAC/ADC overlapping */

	C3X_XINT_CLEAR(0);
	C3X_XINT_ENABLE(0);

	*C3X_TM0_GC		= TM_GC_DATA | TM_GC_GO_MASK	;

 }

		/* X/R interrupt handler parameters	*/

int	dac_scan_flag		= ML_OFF,
	dac_cyclic_scan_flag	= ML_OFF,
	dac_data_start_ptr,
        dac_get_ptr,
	dac_data_count,
        dac_data_count_max;


int	adc_scan_flag		= ML_OFF,
	adc_cyclic_scan_flag	= ML_OFF,
	adc_save_ptr,
	adc_data_start_ptr,
	adc_data_count,
	adc_data_count_max ;


#define data			0x0000
#define end_of_scan		0x020000


unsigned chan_count = 0, max_chan,
	 module_id  = 0;

void c_int01()   /* Fscan interrupt */
{
    unsigned eos, adc_ch, dac_ch ;
    unsigned dac_data ;
    unsigned x_data ;


        if(dac_scan_flag==ML_ON)
	  {
	   adc_ch = chan_count << 18 ;
	   dac_ch = chan_count << 14 ;

	   if(chan_count==max_chan) eos=end_of_scan;
	    else eos=0;

	   dac_data = ((*((int*)(dac_get_ptr + (dac_data_count_max * chan_count))))) & 0x000fff ;

	   x_data = (module_id| adc_ch | eos | dac_ch | dac_data );

           *C3X_SIO0_XD = (x_data) ;

	   if( ++chan_count > max_chan)
	    {
	    	dac_get_ptr++;
		chan_count=0;

	     if(++dac_data_count >=dac_data_count_max)
	       { if(dac_cyclic_scan_flag==ML_ON)
	            {
	               dac_data_count=0;
	               dac_get_ptr=dac_data_start_ptr;
	            }
	          else
	            dac_scan_flag=ML_OFF;
	       }
	    }
	  }
	 else
	  *C3X_SIO0_XD=end_of_scan  ;

}




unsigned r_data;

void c_int10()   /*  receiver#0 interrupt */
{
   long  n_ch;

     	r_data=(*C3X_SIO0_RD);
	n_ch=((r_data>>12) & 0x7);
	r_data= ((((long)r_data)) <<20 )>>20;

        if(adc_scan_flag==ML_ON)
	  {
           *((int *)(adc_save_ptr+(adc_data_count_max*n_ch)))=r_data;
	   if(n_ch==max_chan)
	    {
	      adc_save_ptr++;
              if(++adc_data_count >=adc_data_count_max)
		 { if(adc_cyclic_scan_flag==ML_ON)
		      {
			adc_data_count=0;
                        adc_save_ptr=adc_data_start_ptr;
		      }
		      else
		        adc_scan_flag=ML_OFF;
		 }
	    }
	  }

}



int	adc_dac_scan()
  {
				/* set X/R interrupt driver parameters */
	adc_data_start_ptr	= (int) ADC;
        adc_save_ptr		= (int) ADC;

        dac_data_count_max	= MCD->epoch_len;
        adc_data_count_max	= MCD->epoch_len;
	dac_data_count		= 0;
	adc_data_count		= 0;

	chan_count		= 0;
	max_chan		= (MCD->chan-1) &7;




	if (MCD->cmnd==MCMND_ADC_TO_DAC)
	  {                       /* settings for ADC->DAC scanning */
	    dac_data_start_ptr		= (int) ADC;
            dac_get_ptr			= (int) ADC;

	    adc_cyclic_scan_flag	= ML_ON;
	    adc_scan_flag		= ML_ON;

	  }
	else
	  {
	    dac_data_start_ptr	= (int) DAC;
            dac_get_ptr		= (int) DAC;

	    adc_cyclic_scan_flag	= ML_OFF;
	    adc_scan_flag		= ML_OFF;
	  }

	dac_cyclic_scan_flag	= ML_ON;
	dac_scan_flag		= ML_ON;


			/* wait for  ABORT*/
	while((MCD->status!=MSTAT_ABORT));

	dac_scan_flag	= ML_OFF;	/* disable DAC transmission */
	adc_scan_flag	= ML_OFF;

	return(MERR_OK);
  }
