/***************************************************************
  T/SBDAS-7890/8420 SIOX-Bus AD/DA DCM defs for C3x/C6x DSP. Rev.1
  (C) MicroLAB Systems Ltd, 1998-2000

  Notes:
    1. This file must be used as .H header file for 32-bit
       C3x/C6x DSP environments of host TORNADO DSP system or
       controller.
    2. All commands are adjusted for 24-bit commands and
       16-bit read-back data words.

****************************************************************/


//============= Command Data Word defs ===============

	//------- SIOX-Bus Device ID
#define TSBDAS_7890_CDW_DEV_ID_BITMASK		0x000007
#define TSBDAS_7890_CDW_DEV_ID_SHIFT		21

	//------- DAC data/channel-selector
#define TSBDAS_7890_CDW_DAC_DATA_BITMASK	0x000fff

#define TSBDAS_7890_CDW_DAC_CHAN_BITMASK	0x000007
#define TSBDAS_7890_CDW_DAC_CHAN_SHIFT		14

	//------- ADC channel-selector/EOS
#define TSBDAS_7890_CDW_ADC_CHAN_BITMASK	0x000007
#define TSBDAS_7890_CDW_ADC_CHAN_SHIFT		18

#define TSBDAS_7890_CDW_EOS					0x020000
#define TSBDAS_7890_CDW_NO_EOS				0x000000

#define TSBDAS_7890_ADC_CHANNELS			8
#define TSBDAS_7890_DAC_CHANNELS			8



//============= ADC OUTPUT Data Word defs ===============

#define TSBDAS_7890_ADCODW_ADC_DATA_BITMASK	0x000fff

#define TSBDAS_7890_ADCODW_ADC_CHAN_BITMASK	0x000007
#define TSBDAS_7890_ADCODW_ADC_CHAN_SHIFT	12

#define TSBDAS_7890_ADCODW_SSP_BITMASK		0x000001
#define TSBDAS_7890_ADCODW_SSP_SHIFT		15



//=============== SIO port configuration =====================
// recommended configuration for C3x DSP:
//       XLen=24bits, Rlen=16bits
//       XCLK - Ext (10MHz fm DCM),  RCLK - Ext
//       FSX - output (1), HS=0, XVAREN=0, XFSM=0
//       FSR - input, RVAREN=1, RFSM=0
//       CLKXP - active low (1), CLKRP - active high,
//       FSXP=FSRP - active low (1)
//		 XINT,RINT =enable

#define	TSBDAS_7890_C3X_SIO_GCRG_DATA		0x029B1204
#define	TSBDAS_7890_C3X_SIO_GCRG_GO_MASK	0x0c000000

#define	TSBDAS_7890_C3X_SIO_XCRG_DATA		0x111
#define	TSBDAS_7890_C3X_SIO_RCRG_DATA		0x111


// recommended configuration for C6201@200MHz and C6701@167MHz DSP:
//       XLen=24bits  Rlen=16bits
//       XCLK - Ext (10MHz fm DCM),  RCLK - Ext
//       FSX - output on DX load event, advance=+1 (one cycle prior data)
//       FSR - advance=0 (data framing)
//       CLKXP - active low (1), CLKRP - active high,
//       FSXP=FSRP - active low (1)

// SPCR: 0000 0000 0000 0000 0000 0000 0000 0000
// PCR:  0000 0000 0000 0000 0000 1000 0000 1110
// XCR:  0000 0000 0000 0001 0000 0000 1000 0000
// RCR:  0000 0000 0000 0000 0000 0000 0100 0000
// SRGR: 0000 0000 0000 0000 0000 0000 0000 0000

#define	TSBDAS_7890_C6X_MCBSP_SPCR_DATA		0x00000000
#define	TSBDAS_7890_C6X_MCBSP_PCR_DATA		0x0000080e
#define	TSBDAS_7890_C6X_MCBSP_XCR_DATA		0x00010080
#define	TSBDAS_7890_C6X_MCBSP_RCR_DATA		0x00000040
#define	TSBDAS_7890_C6X_MCBSP_SRGR_DATA		0x00000000

#define	TSBDAS_7890_C6X_MCBSP_SPCR_GO_MASK	0x00410001

//===========================================================
